/*=============================================================================
vitalnix/daxtraq - User Management UI
main.cpp - D'uh
  Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 1999 - 2003
  -- License restrictions apply (Dual FAL/GPL2).
  -- For details see doc/FAL.txt and doc/GPL2.txt.
=============================================================================*/
#include <sys/stat.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <libHX.h>
#include "dxt/global.hpp"

static void init_var(int, char **);
static void deinit_var(void);
/*static void Mainmenu(void);

HXdlg_pack *Desktop;
struct HXtxd_dev_status _textcon =
 {min_x: 79, min_y: 24, max_x: -1, max_y: -1};
struct _termattr_t _termattr;*/
struct optmap_t Optmap;

//-----------------------------------------------------------------------------
int main(int argc, char **argv) {
  int eax;
  init_var(argc, argv);
//  load_config("/etc/daxtraq.conf");
//  load_config("daxtraq.conf");
  if(!(eax = parse_options(&argc, (const char ***)&argv))) { return !eax; }
  init_applock();
/*  if(Optmap.graphical) {
  int e;
    if((e = HXtxd_dev_init(&_textcon)) < 1) {
      exit_pg(1, "Could not initialize text device: %s\n",
       HXtxd_dev_err[iabs(e)]);
    }
    if(_textcon.cap & HXTXD_CAP_7B) {
     _textcon.cap &= ~(HXTXD_CAP_7B | HXTXD_CAP_8B); }
    if(_textcon.cap & HXTXD_CAP_8B && _textcon.cap & HXTXD_CAP_HC) {
      T_C8 = 1;
      if(_textcon.cap & HXTXD_CAP_XT) { T_XTC8 = 1; }
    }
    Mainmenu();
  } else */ {
    Mainmenu_TX();
  }
  deinit_var();
  exit_pg(!1, NULL);
  return !1;
}

static void init_var(int argc, char **argv) {
  char *p;
  //memset(&_termattr, '\0', sizeof(_termattr));
  memset(&Optmap, '\0', sizeof(Optmap));
  Optmap.progn = "Daxtraq";
  Optmap.progf = "daxtraq";

  Optmap.progv = "v1.90.8.35";
  Optmap.progd = __DATE__ " " __TIME__;

  if(!isatty(fileno(stdin)) && !isatty(fileno(stdout)) &&
   (p = getenv("DISPLAY")) != NULL && p[0] != 0) {
    exit_pg(HX_fsystem(HX_FSYSTEM_ARGV | HX_FSYSTEM_EXEC, "xterm", argv,
     "-geometry", "80x25", "-bg", "black", "-fg", "gray", "-e", NULL),
     "HX_fsystem() unsuccessful");
  }

  HX_strclone(&Optmap.f_lock, "/var/run/daxtraq.pid");
  HX_strclone(&Optmap.f_skeld, "");
  HX_strclone(&Optmap.p_pager, "less");
  HX_strclone(&Optmap.pa_pager, "-IMRS %1$s");

  printf(
    "*****[\e[1m %s %s <devel> (%s) \e[0m]*****\n\n"
    "This program comes with ABSOLUTELY NO WARRANTY; it is free software,\n"
    "you are welcome to redistribute it under certain conditions;\n"
    "for details see the files doc/FAL.txt and doc/GPL2.txt which should\n"
    "have come with this program.\n\n",
    Optmap.progn, Optmap.progv, Optmap.progd
  );

  umask(0077);
  return;
}

static void deinit_var(void) {
  HX_strclone(&Optmap.f_lock, NULL);
  HX_strclone(&Optmap.f_skeld, NULL);
  HX_strclone(&Optmap.p_pager, NULL);
  HX_strclone(&Optmap.pa_pager, NULL);
  unlink(Optmap.f_lock);
  return;
}

/*
static void Mainmenu(void) {
  size_t sx = HXtxd_wingetsx(), sy = HXtxd_wingetsy();
  Desktop = new HXdlg_pack();

  HXdlg_frame *mw_top;
  Desktop->add(mw_top = new HXdlg_frame(sx, 1, 0, 0, _textcon.cap));
  mw_top->ChColor(CL_MTFG, CL_MTBG, HXDLG_CLINV);
  mw_top->Fill();
  mw_top->Print(" %s", Optmap.progn);

  HXdlg_frame *mw_main;
  Desktop->add(mw_main = new HXdlg_frame(sx, sy - 2, 0, 1, _textcon.cap));
  mw_main->ChColor(COL_DGRAY, COL_GRAY);
  if(T_XTC8) { mw_main->Fill(ACS_CKBOARD & 0xFF | HXDLG_CHEXT | HXDLG_CHVRT); }
  else if(T_C8) { mw_main->Fill(176 | HXDLG_CHEXT); }

  HXdlg_frame *mw_bot;  
  Desktop->add(mw_bot = new HXdlg_frame(sx, 1, 0, sy - 1, _textcon.cap));
  mw_bot->ChColor(CL_MTFG, CL_MTBG, HXDLG_CLINV);
  mw_bot->Fill();
  mw_bot->Print(" %s (%s)", Optmap.progv, Optmap.progd);

  HXdlg_frame *mw_menu;
  Desktop->add(mw_menu = new HXdlg_frame(40, sy - 5, 2, 2, _textcon.cap));
  mw_menu->shadow = 1;
  mw_menu->ChColor(CL_WINFG, CL_WINBG);
  mw_menu->Fill();
  mw_menu->DrawBorder("[ Hauptmen ]", "bx");

  Desktop->Show();
  while(getch() != 'q');
  return;
}*/

/*static void Mainmenu(void) {
#define ELEMENTS 8
  byte exitloop = 0, vp = 1;
  unsigned short vx, wh = min(wingetsy(W_desk) - 3, 14),
   ww = min(wingetsx(W_desk) - 6, 39);
  struct dialog_t *d;

  // ----------------------------------------
  d = wdialog(mlf("[ Main menu ]"), ww, wh);
  wbkgdset(d->main, DCOLOR(0, 7));
  if(!OPT.bSeven) {
    for(vx = 2; vx < wingetsx(d->main) - 2; ++vx) {
      mvwaddch(d->main, 6, vx, ACS_HLINE | DCOLOR(0, 7));
      mvwaddch(d->main, 9, vx, ACS_HLINE | DCOLOR(0, 7));
    }
  } else {
    for(vx = 2; vx < wingetsx(d->main) - 2; ++vx) {
      mvwaddch(d->main, 6, vx, '-' | DCOLOR(0, 7));
      mvwaddch(d->main, 9, vx, '-' | DCOLOR(0, 7));
    }
  }

  // ----------------------------------------
  while(!exitloop) {
    int k;
    Mainmenu_drawit(vp, d, 1, 2, mlf("[1] Find changes"));
    Mainmenu_drawit(vp, d, 2, 3, mlf("[2] Apply changes"));
    Mainmenu_drawit(vp, d, 3, 4, mlf("[3] Print password list"));
    Mainmenu_drawit(vp, d, 4, 5, mlf("[4] Add single user"));
    Mainmenu_drawit(vp, d, 5, 7, mlf("[5] User details"));
    Mainmenu_drawit(vp, d, 6, 8, mlf("[6] Recover"));
    Mainmenu_drawit(vp, d, 7, 10, mlf("[9] Help"));
    Mainmenu_drawit(vp, d, 8, 11, mlf("[0] Exit"));
    update_panels();
    doupdate();

    switch(k = tolower(getch())) {
      case -1: break;
      case '1': vp = 1; FindChanges(); break;
      case '2': vp = 2; ApplyChanges(); break;
      case '3': vp = 3; PasswordList(); break;
      case '4': vp = 4; SingleAdd(); break;
      case '5': vp = 5; UserDetails(); break;
      case '6': vp = 6; Recover(); break;
      case '9': case '?':
        vp = 7;
        Help(); break;
      case '0': vp = 0; ++exitloop; break;
      case 13: case '>': case KEY_RIGHT:
        switch(vp) {
          case 1: FindChanges(); break;
          case 2: ApplyChanges(); break;
          case 3: PasswordList(); break;
          case 4: SingleAdd(); break;
          case 5: UserDetails(); break;
          case 6: Recover(); break;
          case 7: Help(); break;
          case 8: ++exitloop; return;
          default: break;
        }
        break;
      case 27:
      case '<':
      case 'q':
      case 'x':
      case KEY_LEFT:
        ++exitloop;
        break;
      case '-':
      case KEY_UP:
        if(--vp < 1) { vp = ELEMENTS; }
        break;
      case 9:
      case '+':
      case KEY_DOWN:
        if(++vp > ELEMENTS) { vp = 1; }
        break;
      case KEY_A1:
      case KEY_HOME:
        vp = 1;
        break;
      case KEY_C1:
      case KEY_END:
        vp = ELEMENTS;
        break;
    }

    update_deskclock(NULL);
    update_panels();
    doupdate();
  }

  return;
#undef ELEMENTS
}

static void Mainmenu_drawit(byte vp, struct dialog_t *info,
 byte pv, unsigned short pr, byte *pm) {
  if(pv == vp) {
    if(has_colors()) { wattrset(info->main, DCOLOR(0, 2));
    } else { wattrset(info->main, A_REVERSE); }
  }
  mvwprintw(info->main, pr, 2, " %-30s >> ", pm);
  if(pv == vp) { wattrset(info->main, DCOLOR(0, 7)); }
  return;
}
*/
//==[ End of file ]============================================================
